;; A partly constructed CLIPS ruleset which attempts to mirror
;; the definition of an assault weapon (see sidebar in Chapter 11).
;; I have left some rules for you to implement.

;; DECLARATIONS

(deftemplate gun
 (field name (type SYMBOL))
 (field class (type SYMBOL))
 (field action (type SYMBOL))
 (field caliber (type FLOAT))
 (field capacity (type INTEGER))
 (field feature (type SYMBOL))
)

(deftemplate assault-weapon
 (field name (type SYMBOL))
)

;; FACTS

;; Only the Heckler & Kock Model 91 and the Benelli qualify as an 
;; assault weapon, given the initial rule set.

(deffacts guns
 (gun (name Browning22) (class rifle) (action semi) (caliber .22)   	
		(capacity 11))
 (gun (name CobrayM11) (class pistol) (action semi) (caliber 9.0) 	
		(capacity 30))
 (gun (name HK91) (class rifle) (action semi) (caliber .308)
		(capacity 20))
 (gun (name Glock17) (class pistol) (action semi) (caliber 9.0) 		
		(capacity 17))
 (gun (name Mossberg500) (class shotgun) (action slide)
		(caliber .410) (capacity 5) (feature pistol-grip))
 (gun (name BenelliSuper90) (class shotgun) (action semi)
		(caliber 12.0) (capacity 5) (feature barrel-shroud))
)

;; RULES

;; The general case

;; Any semi-automatic rifle or shotgun with a capacity of
;; more than 5 rounds

(defrule Part1
 (gun (name ?N) (class ?C&rifle|shotgun) (action semi)
		(capacity ?X&:(> ?X 5)))
 =>
 (assert (assault-weapon (name ?N)))
)

;; Any semi-automatic rifle or shotgun with an offending feature

(defrule Part2
 (gun (name ?N) (class ?C&rifle|shotgun) (action semi)
  (feature ?F&flash-suppressor|barrel-shroud|night-scope))
 =>
 (assert (assault-weapon (name ?N)))
)

;; Any pistol-grip shotgun
;; Insert a rule called pistol-grip here

;; Specific cases

;; A Cobray M11 is an assault weapon
;; Insert a rule called cobray here

;; Exceptions

;; No rimfire rifle is an assault weapon
(defrule rimfire
 ?except <- (gun (name ?N) (class rifle) (caliber .22))
 ?mistake <- (assault-weapon (name ?N))
 =>
 (retract ?mistake)
 (retract ?except)
)

;; No slide-action shotgun is an assault weapon
;; Insert a rule called slide here

;; If you extend the rule set, as indicated above,
;; it will also catch the Cobray M11 as a special case.
;; When you add the 'pistol-grip' rule, you should catch the Mossberg,
;; and when you add the refinement rule about slide-action shotguns,
;; the Mossberg should escape the definition.
